module PrimaryKey
  module Uuid
    module Rails
      class Engine < ::Rails::Engine
        config.after_initialize do |app|
          require "primary_key/uuid/rails/patch"
        end
      end
      def self.generate
        namespace (DateTime.now.to_i*1000000 + DateTime.now.usec)
      end
      def self.namespace identifier
        @uuid_namespace        ||= UUIDTools::UUID.parse "f90fe61d-1778-08a4-308a-3beaa8d3c44c"
        @application_namespace ||= UUIDTools::UUID.sha1_create(@uuid_namespace,::Rails.application.class.parent_name)
        UUIDTools::UUID.sha1_create(@application_namespace,identifier.to_s)
      end
    end
  end
end
