require "uuidtools"

class ActiveRecord::Base
  after_initialize :set_primary_key_uuid
  private
  def set_primary_key_uuid
    return unless self.class.primary_key
    pk = self.class.primary_key
    return unless self.class.columns_hash[pk]
    return unless self.class.columns_hash[pk].sql_type == "uuid"
    id = ::PrimaryKey::Uuid::Rails.generate unless id
    puts self.send(pk)
    return unless self.send(pk).nil?
    puts "Set id to #{id}"
    self.send "#{pk}=".to_sym, id.to_s
  end
end